hough_ta-france_2020
====================

Modelled 24-hour ambient air temperature (Ta) from [Hough et al. (2020) A multi-resolution air temperature model for France from MODIS and Landsat thermal data](https://doi.org/10.1016/j.envres.2020.109244).


Contents
--------

### `fst/ta_1km_{YEAR}.fst`

Annual [fst](https://www.fstpackage.org/) files containing 1 km and 200 m model output (24-hour mimimum, mean, and maximum ambient air temperature).

### `iris/ta_iris_{YEAR}.tar.gz`

Archives of monthly CSV files containing area-weighted 24-hour minimum, mean, and maximum ambient air temperature for [Insee IRIS](https://www.insee.fr/fr/metadonnees/definition/c1523).

Scripts:

* https://gitlab.com/ihough/hough_ta-france_2020/-/blob/master/extract-by-iris.R
* https://gitlab.com/ihough/hough_ta-france_2020/-/blob/master/extract-by-iris.sh

### `netCDF/ta_1km_{YEAR}_nc.tar`

Archives of monthly [netCDF](https://docs.unidata.ucar.edu/netcdf-c/current/) files containing 1 km and 200 m model output (24-hour minimum, mean, and maximum ambient air temperature).

Scripts:

* https://gitlab.com/ihough/hough_ta-france_2020/-/blob/master/pred1km2nc.R
* https://gitlab.com/ihough/hough_ta-france_2020/-/blob/master/pred200m2nc.R
* https://gitlab.com/ihough/hough_ta-france_2020/-/blob/master/preds2nc.sh
