Daily air temperature
=====================

Modelled 24-hour ambient air temperature (Ta) from [Hough et al. (2020) A multi-resolution air temperature model for France from MODIS and Landsat thermal data](https://doi.org/10.1016/j.envres.2020.109244).


Contents
--------

### `mod3_{YEAR}_pred_1km.fst`

Output of 1 km model:

* `date` = Date
* `grd_1km_id` = ID of 1 km grid cell (rounded lat/lon)
* `grd_1km_y` = X-coordinate of 1 km grid cell centroid (EPSG:2154 projection)
* `grd_1km_x` = Y-coordinate of 1 km grid cell centroid (EPSG:2154 projection)
* `tmin` = 24-hour minimum ambient air temperature at 2 m above surface
* `tmean` = 24-hour mean ambient air temperature at 2 m above surface
* `tmax` = 24-hour maximum ambient air temperature at 2 m above surface
* `tmin_src` = source of tmin
  - '1' if tmin was predicted using 'm1' based on land surface temperature (LST)
  - '2' if tmin was predicted using 'm2' based on 'm1' predictions for nearby grid cells
* `tmean_src` = source of tmin
  - '1' if tmean was predicted using 'm1' based on land surface temperature (LST)
  - '2' if tmean was predicted using 'm2' based on 'm1' predictions for nearby grid cells
* `tmax_src` = source of tmin
  - '1' if tmax was predicted using 'm1' based on land surface temperature (LST)
  - '2' if tmax was predicted using 'm2' based on 'm1' predictions for nearby grid cells

Note: the coordinates of the 1 km grid cell centroids are listed in EPSG:2154, but the 1 km grid's native projection is MODIS Sinusoidal (i.e. the cells form a square grid in MODIS Sinusoidal projection).

WKT2:2019 of MODIS Sinusoidal projection:

```
PROJCRS["MODIS Sinusoidal",
    BASEGEOGCRS["Unknown",
        DATUM["Unknown",
            ELLIPSOID["Sphere",6371007.181,0,
                LENGTHUNIT["metre",1,
                    ID["EPSG",9001]]]],
        PRIMEM["Greenwich",0,
            ANGLEUNIT["degree",0.0174532925199433],
            ID["EPSG",8901]]],
    CONVERSION["Unknown",
        METHOD["Sinusoidal"],
        PARAMETER["Longitude of natural origin",0,
            ANGLEUNIT["degree",0.0174532925199433],
            ID["EPSG",8802]],
        PARAMETER["False easting",0,
            LENGTHUNIT["metre",1],
            ID["EPSG",8806]],
        PARAMETER["False northing",0,
            LENGTHUNIT["metre",1],
            ID["EPSG",8807]]],
    CS[Cartesian,2],
        AXIS["(E)",east,
            ORDER[1],
            LENGTHUNIT["metre",1,
                ID["EPSG",9001]]],
        AXIS["(N)",north,
            ORDER[2],
            LENGTHUNIT["metre",1,
                ID["EPSG",9001]]]]
```

### `mod5_{YEAR}_pred_200m.fst`

Output of 200 m model:

* `date` = Date
* `grd_200m_id` = ID of 200 m grid cell (rounded lat/lon)
* `x` = X-coordinate of 200 m grid cell centroid (EPSG:3035 projection)
* `y` = Y-coordinate of 200 m grid cell centroid (EPSG:3035 projection)
* `tmin` = 24-hour minimum ambient air temperature at 2 m above surface
* `tmean` = 24-hour mean ambient air temperature at 2 m above surface
* `tmax` = 24-hour maximum ambient air temperature at 2 m above surface

The coordinates of the 200 m grid cell centroids are listed in EPSG:3035, which is the 200 m grid's native projection (i.e. the cells form a square grid in EPSG:3035).
