IRIS daily air temperature
==========================

Area-weighted 24-hour ambient air temperature (Ta) for Insee [IRIS](https://www.insee.fr/fr/metadonnees/definition/c1523).

Air temperature from [Hough et al. (2020) A multi-resolution air temperature model for France from MODIS and Landsat thermal data](https://doi.org/10.1016/j.envres.2020.109244).

IRIS geography from [IGN Contours...Iris](https://geoservices.ign.fr/contoursiris). Note that IRIS geography varies over time due to changes in commune boundaries.

Files:

`ta_iris-{IRIS YEAR}_{MODEL YEAR}-{MODEL MONTH}.csv`

* `IRIS YEAR` = Year of IRIS geography.
* `MODEL YEAR` = Year of temperature data.
* `MODEL MONTH` = Month of temperature data.

Fields:

* `iris` = IRIS code e.g. '010010000' = commune '01001' IRIS '0000'
* `date` = Date of air temperature.
* `tmin` = Area-weighted 24-hour minimum ambient air temperature at 2 m above surface
* `tmean` = Area-weighted 24-hour mean ambient air temperature at 2 m above surface
* `tmax` = Area-weighted 24-hour maximum ambient air temperature at 2 m above surface

Scripts:

* https://gitlab.com/ihough/hough_ta-france_2020/-/blob/master/extract-by-iris.R
* https://gitlab.com/ihough/hough_ta-france_2020/-/blob/master/extract-by-iris.sh
