Daily air temperature
=====================

Modelled 24-hour ambient air temperature (Ta) from [Hough et al. (2020) A multi-resolution air temperature model for France from MODIS and Landsat thermal data](https://doi.org/10.1016/j.envres.2020.109244).


Contents
--------

### `ta_1km_{YEAR}-{MONTH}.nc`

Output of 1 km model.

Dimensions:

* `time` = Date
* `y` = Y-coordinate of MODIS Sinusoidal projection (see variable `sinusoidal`)
* `x` = X-coordinate of MODIS Sinusoidal projection (see variable `sinusoidal`)

Variables:

* `tmin` = 24-hour minimum ambient air temperature at 2 m above surface
* `tmean` = 24-hour mean ambient air temperature at 2 m above surface
* `tmax` = 24-hour maximum ambient air temperature at 2 m above surface
* `grid_id` = ID of 1 km model grid cell (rounded lat/lon)
* `sinusoidal` = Empty variable with attributes describing the MODIS Sinusoidal projection

### `ta_200m_{YEAR}_nc.tar`

Output of 200 m model.

Dimensions:

* `time` = Date
* `y` = Y-coordinate of EPSG:3035 projection (see variable `epsg3035`)
* `x` = X-coordinate of EPSG:3035 projection (see variable `epsg3035`)

Variables:

* `tmin` = 24-hour minimum ambient air temperature at 2 m above surface
* `tmean` = 24-hour mean ambient air temperature at 2 m above surface
* `tmax` = 24-hour maximum ambient air temperature at 2 m above surface
* `grid_id` = ID of 200 m model grid cell (rounded lat/lon)
* `epsg3035` = Empty variable with attributes describing the EPSG:3035 projection


Scripts
-------

* https://gitlab.com/ihough/hough_ta-france_2020/-/blob/master/pred1km2nc.R
* https://gitlab.com/ihough/hough_ta-france_2020/-/blob/master/pred200m2nc.R
* https://gitlab.com/ihough/hough_ta-france_2020/-/blob/master/preds2nc.sh
