# Nash-Sutcliffe model efficiency factor
# Equivalent to R2 except may be < 0 if model is worse predictor than the mean of all observations
mef <- function(dtable, obs_col, pred_col) {

  obs_mean <- dtable[[obs_col]] %>% mean
  resid_var <- (dtable[[pred_col]] - dtable[[obs_col]])^2 %>% sum
  initial_var <- (dtable[[obs_col]] - obs_mean)^2 %>% sum
  1 - (resid_var / initial_var)

}
