# Scale a data table's columns by the specified factors
scale_cols <- function(dat, scales) {
  for (colname in names(scales)) {
    center <- scales[[colname]][["scaled:center"]]
    scaler <- scales[[colname]][["scaled:scale"]]
    dat[, (colname) := get(colname) %>% scale(center = center, scale = scaler)]
  }
}
