# Split something into a list of n approximately equal groups
split_into_n <- function(x, n) {

  # Get the number of elements or rows in x
  if (is.null(nrow(x))) {
    lngth <- length(x)
  } else {
    lngth <- nrow(x)
  }

  groups <- ceiling(1:lngth / (lngth / n))

  # Split
  if (exists("is.data.table") && is.data.table(x)) {

    x[, split_into_n_group := groups]
    split(x, by = "split_into_n_group") %>% lapply(function(splt) {
      splt[, split_into_n_group := NULL]
    })

  } else {

    split(x, groups)

  }

}
