#
# Install required packages
#

pkgs <- list(

          # Geospatial
          "sf",
          "sp",
          "rgdal",
          "rgeos",
          "raster",
          "gdalUtils",
          "velox",
          "gstat",
          "spdep",
          "mapview",
          "nngeo",

          # Modeling
          "igraph",
          "FNN",
          "lme4",
          "nlme",
          "mgcv",
          "ranger",
          "xgboost",
          "DiceKriging", # for mlrMBO?
          "rgenoud",     # for mlrMBO?
          "mlr",
          "mlrMBO",

          # General
          "magrittr",
          "parallel",
          "fst",
          "glue",
          "lubridate",
          "foreign",
          "yaml",
          "ggplot2",
          "devtools",

          # Load last to avoid masking
          "data.table"

        )
lapply(pkgs, function(p) {
  installed <- installed.packages()[, "Package"]
  install.packages(
    pkgs = setdiff(p, installed),
    repos = c(CRAN = "https://cloud.r-project.org")
  )
})

dev_pkgs <- c(
              "allanjust/aodlur"
            )
lapply(dev_pkgs, function(p) {
  devtools::install_github(p)
})
